package fluxandmonoplayground;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.test.StepVerifier;

public class FluxAndmonoTest {
    @Test
    public void fluxTest() {
        Flux<String> stringFlux = Flux.just("Spring", "Spring Boot", "Reactive Spring")
                /* .concatWith(Flux.error(new RuntimeException("Exception occurred")))*/
                .concatWith(Flux.just("After error"))
                .log();
        stringFlux.subscribe(System.out::println,
                (e) -> System.err.println("Exception is " + e)
                , () -> System.out.println("completed"));

    }

    @Test
    public void fluxTextElements_withoutError() {
        Flux<String> stringFlux = Flux.just("Spring", "Springboot", "Reactive Spring")
                .log();
        StepVerifier.create(stringFlux)
                .expectNext("Spring")
                .expectNext("Springboot")
                .expectNext("Reactive Spring")
                .verifyComplete();
    }
    @Test
    public void fluxTestElements_withError(){
        Flux<String> stringFlux = Flux.just("Spring", "Springboot", "Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Exception Occurred")))
                .log();
        StepVerifier.create(stringFlux)
                .expectNext("Spring")
                .expectNext("Springboot")
                .expectNext("Reactive Spring")
                //.expectError(RuntimeException.class)
                .expectErrorMessage("Exception Occurred")
                .verify();

    }
    @Test
    public void fluxTestElementsCount_withError() {
        Flux<String> stringFlux = Flux.just("Spring", "Springboot", "Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Exception Occurred")))
                .log();
        StepVerifier.create(stringFlux)
                .expectNextCount(3)

                .expectErrorMessage("Exception Occurred")
                .verify();

    }

    @Test
    public void fluxTestElements_withError1() {
        Flux<String> stringFlux = Flux.just("Spring", "Springboot", "Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Exception Occurred")))
                .log();
        StepVerifier.create(stringFlux)
                .expectNext("Spring", "Springboot", "Reactive Spring")
                //.expectError(RuntimeException.class)
                .expectErrorMessage("Exception Occurred")
                .verify();
    }
    @Test
    public void monoTest(){
   Mono<String> stringMono=Mono.just("Spring");
   StepVerifier.create(stringMono.log())
           .expectNext("Spring")
           .verifyComplete();
    }
    @Test
    public void monoTest_Error(){
        StepVerifier.create(Mono.error(new RuntimeException("Exception Occurred")).log())
                .expectError(RuntimeException.class)
                .verify();
    }

    }



